open Cpcore

let inList x = either nil cons x

let outList l = match l with
    | [] -> i1 ()
    | (x::xs) -> i2 (x,xs)

let baseList g f = id -|- (g >< f)


(* (2) Ana + cata + hylo) ----------------------------------------------- *)

let recList f l = (id -|- (id >< f)) l
 
let rec cataList g l = (g <. recList (cataList g) <. outList) l

let rec anaList g l = (inList <. recList (anaList g) <. g) l

let hyloList f g l = (cataList f -|- anaList g) l

let rec len l = match l with
    | [] -> 0
    | (_::xs) -> 1 + len xs

let head l = match l with
    | [] -> 0
    | (x::_) -> x

let sum l = cataList (either (const 0) (add)) l


